<?php
  define('MODULE_PAYMENT_WIRECARD_CCARD_STATUS_TITLE', 'Status:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_STATUS_DESC', 'Do you want to offer WireCard CC ?');

  define('MODULE_PAYMENT_WIRECARD_CCARD_DEMO_TITLE', 'Demo:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_DEMO_DESC', 'Do you want to use WireCard CC in demo mode ?');
  
  define('MODULE_PAYMENT_WIRECARD_CCARD_URL_TITLE', 'Wirecard URL: ');
  define('MODULE_PAYMENT_WIRECARD_CCARD_URL_DESC', 'URL of the HTTPS Gateway of the Wire Card II RPI platform offers a flexible and secure communication for FirePay payment requests and responses.');
  
  define('MODULE_PAYMENT_WIRECARD_CCARD_ZONE_TITLE', 'Zone:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_ZONE_DESC', 'If a zone is selected, only enable this payment method for that zone.');
  
  define('MODULE_PAYMENT_WIRECARD_CCARD_ORDER_STATUS_ID_TITLE', 'Orderstatus:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_ORDER_STATUS_ID_DESC', 'Please choose the status of orders which are NOT paid.');

  define('MODULE_PAYMENT_WIRECARD_CCARD_ORDER_STATUS_PAID_ID_TITLE', 'Orderstatus paid:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_ORDER_STATUS_PAID_ID_DESC', 'Please choose the status of orders which are paid.');
  
  define('MODULE_PAYMENT_WIRECARD_CCARD_CURL_PATH_TITLE', 'CURL Path:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_CURL_PATH_DESC', 'Path to CURL binary. (NONE - use built-in PHP CURL methods).');
  
  define('MODULE_PAYMENT_WIRECARD_CCARD_SORT_ORDER_TITLE', 'Sort order:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_SORT_ORDER_DESC', 'Sort order of display. Lowest is displayed first.');

  define('MODULE_PAYMENT_WIRECARD_CCARD_DEBUG_TITLE', '<br><hr>Debug-Mode');
  define('MODULE_PAYMENT_WIRECARD_CCARD_DEBUG_DESC', 'If you got problems, the debug mode will show a xml-block for the support.');
  
  define('MODULE_PAYMENT_WIRECARD_CCARD_TEXT_TITLE', 'Creditcard<br>
  <a href="https://www.wirecard.com/wirecard"><img src="http://www.wirecard.de/brand-center/wirecard-wb-m.gif" border=0 alt="wirecard"></a>');
  define('MODULE_PAYMENT_WIRECARD_CCARD_TEXT_DESCRIPTION', 'Creditcard Test Info:<br><br>CC#: 4200000000000000<br>Valid until: Any');
  define('MODULE_PAYMENT_WIRECARD_CCARD_ERROR_HEADING', 'The following error occured while Wire Card CC process:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_ERROR_MESSAGE', 'Please check your creditcard data!');
  define('MODULE_PAYMENT_WIRECARD_CCARD_ERROR_CURL', 'No CURL connection or CURL configuration found!');

  define('MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_OWNER', 'Creditcard Owner');
  define('MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_NUMBER', 'Creditcard-No.:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_EXPIRES', 'Valid until:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_START', 'Valid from:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_ISSUENUMBER', 'ISSUE Number:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_MAESTRO_TEXT', 'Optional fields with Maestro. <br>Please enter if on your card.');
  define('MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_CHECKNUMBER', 'Card checknumber');
  define('MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_CHECKNUMBER_LOCATION', '(On the back side of your creditcard in the sign field)');
  define('MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_TYPE', 'Card-Type');
  define('MODULE_PAYMENT_WIRECARD_CCARD_ACCEPTED_CARDS', 'The following cards are accepted:');

  define('MODULE_PAYMENT_WIRECARD_CCARD_TEXT_JS_CC_OWNER', '* The name of the creditcard owner has to be at least ' . CC_OWNER_MIN_LENGTH . ' characters long.');
  define('MODULE_PAYMENT_WIRECARD_CCARD_TEXT_JS_CC_NUMBER', '* The \'Creditcard-No.\' has a minimum of ' . CC_NUMBER_MIN_LENGTH . ' digits length.');
  define('MODULE_PAYMENT_WIRECARD_CCARD_TEXT_JS_CC_ISSUENUMBER', '* The \'ISSUE-No.\' is too short.');
  define('MODULE_PAYMENT_WIRECARD_CCARD_TEXT_JS_CC_CVV', '* The \'CVV\' is too short.');

  define('TEXT_WIRECARD_VAL_ERROR_INVALID_DATE', 'The "Valid until" Date is invalid. Please correct your entries.');
  define('TEXT_WIRECARD_VAL_ERROR_INVALID_STARTDATE', 'The "Valid from" Date is invalid. Please correct your entries.');
  define('TEXT_WIRECARD_VAL_ERROR_INVALID_NUMBER', 'The "Creditcard-Number" is invalid. Please correct your entries.');
  define('TEXT_WIRECARD_VAL_ERROR_UNKNOWN_CARD', 'The first 4 digits of your creditcard are: %s If this is correct, your card type is not accepted. Please correct your entries.');
  
  define('MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_MASTERCARD_TITLE', '<br><hr>Accept MASTERCARD');
  define('MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_MASTERCARD_DESC', 'Accept MASTERCARD');
  define('MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_USER_ID_TITLE', 'MASTERCARD User ID:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_USER_ID_DESC', 'The user ID for the Wire Card CC service');
  define('MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_PASSWORD_TITLE', 'MASTERCARD User Password:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_PASSWORD_DESC', 'The user password for the Wire Card CC service');
  define('MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_CASE_SIGNATURE_TITLE', 'MASTERCARD Case Signature:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_CASE_SIGNATURE_DESC', 'Please enter your Business Case Signature');
  define('MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_IS3DS_TITLE', 'MASTERCARD with 3D Secure:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_IS3DS_DESC', 'Please choose TRUE if you own a 3D Secure Business Case.');
  
  define('MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_VISA_TITLE', '<br><hr>Accept VISA');
  define('MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_VISA_DESC', 'Accept VISA');
  define('MODULE_PAYMENT_WIRECARD_CCARD_VISA_USER_ID_TITLE', 'VISA User ID:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_VISA_USER_ID_DESC', 'The user ID for the Wire Card CC service');
  define('MODULE_PAYMENT_WIRECARD_CCARD_VISA_PASSWORD_TITLE', 'VISA User Password:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_VISA_PASSWORD_DESC', 'The user password for the Wire Card CC service');
  define('MODULE_PAYMENT_WIRECARD_CCARD_VISA_CASE_SIGNATURE_TITLE', 'VISA Case Signature:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_VISA_CASE_SIGNATURE_DESC', 'Please enter your Business Case Signature');
  define('MODULE_PAYMENT_WIRECARD_CCARD_VISA_IS3DS_TITLE', 'VISA with 3D Secure:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_VISA_IS3DS_DESC', 'Please choose TRUE if you own a 3D Secure Business Case.');
  
  define('MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_JCB_TITLE', '<br><hr>Accept JCB');
  define('MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_JCB_DESC', 'Accept JCB');
  define('MODULE_PAYMENT_WIRECARD_CCARD_JCB_USER_ID_TITLE', 'JCB User ID:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_JCB_USER_ID_DESC', 'The user ID for the Wire Card CC service');
  define('MODULE_PAYMENT_WIRECARD_CCARD_JCB_PASSWORD_TITLE', 'JCB User Password:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_JCB_PASSWORD_DESC', 'The user password for the Wire Card CC service');
  define('MODULE_PAYMENT_WIRECARD_CCARD_JCB_CASE_SIGNATURE_TITLE', 'JCB Case Signature:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_JCB_CASE_SIGNATURE_DESC', 'Please enter your Business Case Signature');
  define('MODULE_PAYMENT_WIRECARD_CCARD_JCB_IS3DS_TITLE', 'JCB with 3D Secure:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_JCB_IS3DS_DESC', 'Please choose TRUE if you own a 3D Secure Business Case.');
  
  define('MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_AMEX_TITLE', '<br><hr>Accept AMERICAN EXPRESS');
  define('MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_AMEX_DESC', 'Accept AMERICAN EXPRESS');
  define('MODULE_PAYMENT_WIRECARD_CCARD_AMEX_USER_ID_TITLE', 'AMERICAN EXPRESS User ID:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_AMEX_USER_ID_DESC', 'The user ID for the Wire Card CC service');
  define('MODULE_PAYMENT_WIRECARD_CCARD_AMEX_PASSWORD_TITLE', 'AMERICAN EXPRESS User Password:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_AMEX_PASSWORD_DESC', 'The user password for the Wire Card CC service');
  define('MODULE_PAYMENT_WIRECARD_CCARD_AMEX_CASE_SIGNATURE_TITLE', 'AMERICAN EXPRESS Case Signature:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_AMEX_CASE_SIGNATURE_DESC', 'Please enter your Business Case Signature');
  define('MODULE_PAYMENT_WIRECARD_CCARD_AMEX_IS3DS_TITLE', 'AMERICAN EXPRESS with 3D Secure:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_AMEX_IS3DS_DESC', 'Please choose TRUE if you own a 3D Secure Business Case.');

  define('MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_MAESTRO_TITLE', '<br><hr>Accept MAESTRO');
  define('MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_MAESTRO_DESC', 'Accept MAESTRO');
  define('MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_USER_ID_TITLE', 'MAESTRO User ID:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_USER_ID_DESC', 'The user ID for the Wire Card CC service');
  define('MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_PASSWORD_TITLE', 'MAESTRO User Password:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_PASSWORD_DESC', 'The user password for the Wire Card CC service');
  define('MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_CASE_SIGNATURE_TITLE', 'MAESTRO Case Signature:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_CASE_SIGNATURE_DESC', 'Please enter your Business Case Signature');
  define('MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_IS3DS_TITLE', 'MAESTRO with 3D Secure:');
  define('MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_IS3DS_DESC', 'Please choose TRUE if you own a 3D Secure Business Case.');
  
?>
