<?
if (file_exists(DIR_FS_CATALOG.DIR_WS_CLASSES . 'class.wirecard.php')){
  include(DIR_FS_CATALOG.DIR_WS_CLASSES . 'class.wirecard.php');
} else {
  include(DIR_WS_CLASSES . 'class.wirecard.php');
}

class wirecard_ccard
{
  var $code, $title, $description, $enabled;
  var $wc = '';

  function wirecard_ccard()/*{{{*/
  {
    global $order, $xtPrice;
    $this->wc = & new wirecard();

    $this->code = 'wirecard_ccard';
    $this->title = MODULE_PAYMENT_WIRECARD_CCARD_TEXT_TITLE;
    $this->description = MODULE_PAYMENT_WIRECARD_CCARD_TEXT_DESCRIPTION;
    $this->sort_order = MODULE_PAYMENT_WIRECARD_CCARD_SORT_ORDER;
    $this->enabled = ((MODULE_PAYMENT_WIRECARD_CCARD_STATUS == 'True') ? true : false);
    if ((int)MODULE_PAYMENT_WIRECARD_CCARD_ORDER_STATUS_ID > 0) $this->order_status = MODULE_PAYMENT_WIRECARD_CCARD_ORDER_STATUS_ID;

    // kein Redirect vor dem Bestellen
    $this->tmpOrders = true;
    $this->sid = session_name().'='.session_id();
    $this->order_status = MODULE_PAYMENT_WIRECARD_CCARD_ORDER_STATUS_ID;
    $this->tmpStatus = $this->order_status;
    $this->form_action_url = tep_href_link('checkout_process.php', $this->sid, 'SSL', '', false);
  }/*}}}*/

  function update_status()/*{{{*/
  {
    global $order;

    if (($this->enabled == true) && ((int)MODULE_PAYMENT_WIRE_CARD_C3_ZONE > 0))
    {
      $check_flag = false;
      $check_query = tep_db_query("
        select zone_id 
        from " . TABLE_ZONES_TO_GEO_ZONES . " 
        where 
        geo_zone_id = '" . MODULE_PAYMENT_WIRE_CARD_C3_ZONE . "' 
        and zone_country_id = '" . $order->billing['country']['id'] . "' 
        order by zone_id");

      while ($check = tep_db_fetch_array($check_query))
      {
        if ($check['zone_id'] < 1)
        {
          $check_flag = true;
          break;
        }
        elseif ($check['zone_id'] == $order->billing['zone_id'])
        {
          $check_flag = true;
          break;
        }
      }

      if ($check_flag == false)
      {
        $this->enabled = false;
      }
    }
  }/*}}}*/

  function javascript_validation()/*{{{*/
  {
    $js = '
      if (payment_value == "' . $this->code . '") {
        var wc_cc_owner = document.getElementById("wc_cc_owner").value;
        var wc_cc_number = document.getElementById("wc_cc_number").value;
        var wc_cc_checkcode = document.getElementById("wc_cc_checkcode").value;
        var wc_cc_issuenumber = document.getElementById("wc_cc_issuenumber").value;
        if (wc_cc_owner == "" || wc_cc_owner.length < '.CC_OWNER_MIN_LENGTH.'){
          alert("'.MODULE_PAYMENT_WIRECARD_CCARD_TEXT_JS_CC_OWNER.'");
          return false;
        }
        if (wc_cc_number == "" || wc_cc_number.length < '.CC_NUMBER_MIN_LENGTH.'){
          alert("'.MODULE_PAYMENT_WIRECARD_CCARD_TEXT_JS_CC_NUMBER.'");
          return false;
        }
        if (wc_cc_checkcode == "" || wc_cc_checkcode.length < '.CC_CVV_MIN_LENGTH.'){
          alert("'.MODULE_PAYMENT_WIRECARD_CCARD_TEXT_JS_CC_CVV.'");
          return false;
        }
        if (wc_cc_issuenumber == "" || wc_cc_issuenumber.length < '.CC_ISSUENUMBER_MIN_LENGTH.'){
          //alert("'.MODULE_PAYMENT_WIRECARD_CCARD_TEXT_JS_CC_ISSUENUMBER.'");
          //return false;
        }
      }
    ';
    
    return $js;
  }/*}}}*/

  function selection()/*{{{*/
  {
    global $order;

    $customerId = $_SESSION['customer_id'];
    //if ($this->wc->getCustomerStopLight($customerId) < WC_CLEAR_YELLOW) return false;

    for ($i=1; $i < 13; $i++) {
      $month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%B',mktime(0,0,0,$i,1,2000)));
    }
    $today = getdate(); 
    for ($i=$today['year']; $i < $today['year']+10; $i++) {
      $expires_year[] = array('id' => strftime('%y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
    }
    $start_month[] = array('id' => '', 'text' => '-');
    for ($i=1; $i < 13; $i++) {
      $start_month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%B',mktime(0,0,0,$i,1,2000)));
    }
    $start_year[] = array('id' => '', 'text' => '-');
    for ($i=$today['year']-4; $i <= $today['year']; $i++) {
      $start_year[] = array('id' => strftime('%y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
    }

    $card_types = array();
    if (strtolower(MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_VISA) == 'true')
      $card_types[] = array('id' => WIRE_CCARD_TYPE_VISA, 'text' => WIRE_CCARD_TYPE_VISA);
    if (strtolower(MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_MASTERCARD) == 'true')
      $card_types[] = array('id' => WIRE_CCARD_TYPE_MASTERCARD, 'text' => WIRE_CCARD_TYPE_MASTERCARD);
    if (strtolower(MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_JCB) == 'true')
      $card_types[] = array('id' => WIRE_CCARD_TYPE_JCB, 'text' => WIRE_CCARD_TYPE_JCB);
    if (strtolower(MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_AMEX) == 'true')
      $card_types[] = array('id' => WIRE_CCARD_TYPE_AMEX, 'text' => WIRE_CCARD_TYPE_AMEX);
    if (strtolower(MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_MAESTRO) == 'true')
      $card_types[] = array('id' => WIRE_CCARD_TYPE_MAESTRO, 'text' => WIRE_CCARD_TYPE_MAESTRO);

    $selectedStartMonth = '';
    if (isset($_REQUEST['wirecard_ccard_cc_start_month'])) $selectedStartMonth = $_REQUEST['wirecard_ccard_cc_start_month'];
    $selectedStartYear = '';
    if (isset($_REQUEST['wirecard_ccard_cc_start_year'])) $selectedStartYear = $_REQUEST['wirecard_ccard_cc_start_year'];
    $selectedExpireMonth = date('m');
    if (isset($_REQUEST['wirecard_ccard_cc_expires_month'])) $selectedExpireMonth = $_REQUEST['wirecard_ccard_cc_expires_month'];
    $selectedExpireYear = date('y');
    if (isset($_REQUEST['wirecard_ccard_cc_expires_year'])) $selectedExpireYear = $_REQUEST['wirecard_ccard_cc_expires_year'];
    $owner = $order->billing['firstname'] . ' ' . $order->billing['lastname'];
    if (isset($_REQUEST['wirecard_ccard_cc_owner'])) $owner = $_REQUEST['wirecard_ccard_cc_owner'];
    $selectedType = '';
    if (isset($_REQUEST['wirecard_ccard_cc_type'])) $selectedType = $_REQUEST['wirecard_ccard_cc_type'];
    
    $selection = array(
      'id' => $this->code,
      'module' => $this->title,
      'fields' => array(
        array('title' => MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_OWNER,
        'field' => tep_draw_input_field('wirecard_ccard_cc_owner', $owner, 'id="wc_cc_owner"')),
        array('title' => MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_NUMBER,
        'field' => tep_draw_input_field('wirecard_ccard_cc_number', '', 'maxlength="19" id="wc_cc_number"')),
        array('title' => MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_EXPIRES,
        'field' => tep_draw_pull_down_menu('wirecard_ccard_cc_expires_month', $month, $selectedExpireMonth) . '&nbsp;' . tep_draw_pull_down_menu('wirecard_ccard_cc_expires_year', $expires_year, $selectedExpireYear)),
        array('title' => MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_CHECKNUMBER,
        'field' => tep_draw_input_field('wirecard_ccard_cc_checkcode', '', 'size="4" maxlength="4" id="wc_cc_checkcode"') . '&nbsp;<small>' . MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_CHECKNUMBER_LOCATION . '</small>'),
        array('title' => MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_TYPE,
        'field' => tep_draw_pull_down_menu('wirecard_ccard_cc_type', $card_types, $selectedType)),
      ));
    if (strtolower(MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_MAESTRO) == 'true'){
      $selection['fields'][] = array('title' => MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_START.' *',
        'field' => tep_draw_pull_down_menu('wirecard_ccard_cc_start_month', $start_month, $selectedStartMonth) . '&nbsp;' . tep_draw_pull_down_menu('wirecard_ccard_cc_start_year', $start_year, $selectedStartYear));
      $selection['fields'][] = array('title' => MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_ISSUENUMBER.' *',
        'field' => tep_draw_input_field('wirecard_ccard_cc_issuenumber', '', 'maxlength="3" size="2" id="wc_cc_issuenumber"'));
      $selection['fields'][] = array('title' => '* '.MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_MAESTRO_TEXT,
        'field' => '');
    }

    return $selection;
  }/*}}}*/

  function pre_confirmation_check()/*{{{*/
  {
    if ($_POST['wirecard_ccard_cc_type'] == WIRE_CCARD_TYPE_MAESTRO){
      $this->wc->cc_number = ereg_replace('[^0-9]', '', $_POST['wirecard_ccard_cc_number']);
      $this->wc->cc_type = WIRE_CCARD_TYPE_MAESTRO;
      $this->wc->cc_expiry_month = $_POST['wirecard_ccard_cc_expires_month'];
      $this->wc->cc_expiry_year = $_POST['wirecard_ccard_cc_expires_year'];
      $this->cc_issuenumber = $_POST['wirecard_ccard_cc_issuenumber'];
      $this->cc_start_month = $_POST['wirecard_ccard_cc_start_month'];
      $this->cc_start_year = $_POST['wirecard_ccard_cc_start_year'];
      $result = true;
    } else {
      $result = $this->wc->validate($_POST['wirecard_ccard_cc_number'], $_POST['wirecard_ccard_cc_expires_month'], $_POST['wirecard_ccard_cc_expires_year']);
    }
    $error = '';
    switch ($result)
    {
    case -1:
      $error = sprintf(TEXT_WIRECARD_VAL_ERROR_UNKNOWN_CARD, substr($this->wc->cc_number, 0, 4));
      break;
    case -2:
    case -3:
    case -4:
      $error = TEXT_WIRECARD_VAL_ERROR_INVALID_DATE;
      break;
    case false:
      $error = TEXT_WIRECARD_VAL_ERROR_INVALID_NUMBER;
      break;
    }

    if (empty($_POST['wirecard_ccard_cc_checkcode']) || empty($_POST['wirecard_ccard_cc_checkcode'])){
      $error = MODULE_PAYMENT_WIRECARD_CCARD_TEXT_JS_CC_CVV;
      $result = false;
    }
    /*
    if (strtolower(MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_MAESTRO) == 'true' && $_POST['wirecard_ccard_cc_type'] == WIRE_CCARD_TYPE_MAESTRO){
      if (empty($_POST['wirecard_ccard_cc_start_month']) || empty($_POST['wirecard_ccard_cc_start_year'])){
        $error = TEXT_WIRECARD_VAL_ERROR_INVALID_STARTDATE;
        $result = false;
      }
    }
     */
    
    if ( ($result == false) || ($result < 1) )
    {
      $error = html_entity_decode($error);
      $payment_error_return = 'payment_error=' . $this->code 
        . '&error=' . urlencode($error) 
        . '&wirecard_ccard_cc_owner=' . urlencode($_POST['wirecard_ccard_cc_owner']) 
        . '&wirecard_ccard_cc_expires_month=' . $_POST['wirecard_ccard_cc_expires_month'] 
        . '&wirecard_ccard_cc_expires_year=' . $_POST['wirecard_ccard_cc_expires_year'] 
        . '&wirecard_ccard_cc_type=' . $_POST['wirecard_ccard_cc_type'];
      if (strtolower(MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_MAESTRO) == 'true' && $_POST['wirecard_ccard_cc_type'] == WIRE_CCARD_TYPE_MAESTRO){
        $payment_error_return.= '&wirecard_ccard_cc_start_month=' . $_POST['wirecard_ccard_cc_start_month'] 
        . '&wirecard_ccard_cc_start_year=' . $_POST['wirecard_ccard_cc_start_year'] 
        . '&wirecard_ccard_cc_issuenumber=' . $_POST['wirecard_ccard_cc_issuenumber'];
      }

      tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
    }

    $this->cc_card_type = $this->wc->cc_type;
    $this->cc_card_number = $this->wc->cc_number;
    $this->cc_expiry_month = $this->wc->cc_expiry_month;
    $this->cc_expiry_year = $this->wc->cc_expiry_year;
  }/*}}}*/

  function confirmation()/*{{{*/
  {

    $confirmation = array(
      'title' => $this->title,# . ': ' . $this->cc_card_type,
      'fields' => array(
        array('title' => MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_OWNER,
        'field' => $_POST['wirecard_ccard_cc_owner']),
        array('title' => MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_NUMBER,
        'field' => substr($this->cc_card_number, 0, 4) . str_repeat('X', (strlen($this->cc_card_number) - 8)) . substr($this->cc_card_number, -4)),
        array('title' => MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_EXPIRES,
        'field' => strftime('%B, %Y', mktime(0,0,0,$_POST['wirecard_ccard_cc_expires_month'], 1, '20' . $_POST['wirecard_ccard_cc_expires_year'])))
      ));

    if (tep_not_null($_POST['wirecard_ccard_cc_checkcode'])) {
      $confirmation['fields'][] = array('title' => MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_CHECKNUMBER,
        'field' => $_POST['wirecard_ccard_cc_checkcode']);
    }

    if (tep_not_null($this->cc_card_type)) {
      $confirmation['fields'][] = array('title' => MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_TYPE,
        'field' => $this->cc_card_type);
    }

    if ($_POST['wirecard_ccard_cc_type'] == WIRE_CCARD_TYPE_MAESTRO){
      if (tep_not_null($this->cc_card_type) && $_POST['wirecard_ccard_cc_start_month'] > 0 && $_POST['wirecard_ccard_cc_start_year'] > 0) {
        $confirmation['fields'][] = array('title' => MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_START,
          'field' => strftime('%B, %Y', mktime(0,0,0,$_POST['wirecard_ccard_cc_start_month'], 1, '20' . $_POST['wirecard_ccard_cc_start_year'])));
      }
      if (tep_not_null($this->cc_card_type) && $this->cc_issuenumber > 0) {
        $confirmation['fields'][] = array('title' => MODULE_PAYMENT_WIRECARD_CCARD_TEXT_CREDIT_CARD_ISSUENUMBER,
          'field' => $this->cc_issuenumber);
      }
    }

    return $confirmation;
  }/*}}}*/

  function process_button()/*{{{*/
  {
    global $_POST;

    $process_button_string = tep_draw_hidden_field('cc_expdate_month', $_POST['wirecard_ccard_cc_expires_month']) .
      tep_draw_hidden_field('cc_expdate_year', $_POST['wirecard_ccard_cc_expires_year']) .
      tep_draw_hidden_field('cc_number', $_POST['wirecard_ccard_cc_number']) .
      tep_draw_hidden_field('cc_checkcode', $_POST['wirecard_ccard_cc_checkcode']) .
      tep_draw_hidden_field('cc_owner', $_POST['wirecard_ccard_cc_owner']) .
      tep_draw_hidden_field('cc_type', $this->cc_card_type) .
      tep_draw_hidden_field('cc_expires', $_POST['wirecard_ccard_cc_expires_month'] . $_POST['wirecard_ccard_cc_expires_year']) .
      tep_draw_hidden_field('cc_issuenumber', $_POST['wirecard_ccard_cc_issuenumber']) .
      tep_draw_hidden_field('cc_start_month', $_POST['wirecard_ccard_cc_start_month']) .
      tep_draw_hidden_field('cc_start_year', $_POST['wirecard_ccard_cc_start_year']);

    return $process_button_string;
  }/*}}}*/

  function before_process()/*{{{*/
  {
  }/*}}}*/

  function payment_action()/*{{{*/
  {
    global $order, $xtPrice, $insert_id, $email_order, $cart;

    $currency = $_SESSION['currency'];

    $amount = $this->wc->getTotalAmount();

    # Daten ermitteln
    switch($_POST['cc_type']){
    case WIRE_CCARD_TYPE_VISA:
      $user_id = MODULE_PAYMENT_WIRECARD_CCARD_VISA_USER_ID;
      $user_pwd = MODULE_PAYMENT_WIRECARD_CCARD_VISA_PASSWORD;
      $signature = MODULE_PAYMENT_WIRECARD_CCARD_VISA_CASE_SIGNATURE;
      $is3DS = (MODULE_PAYMENT_WIRECARD_CCARD_VISA_IS3DS=='true');
      break;
    case WIRE_CCARD_TYPE_JCB:
      $user_id = MODULE_PAYMENT_WIRECARD_CCARD_JCB_USER_ID;
      $user_pwd = MODULE_PAYMENT_WIRECARD_CCARD_JCB_PASSWORD;
      $signature = MODULE_PAYMENT_WIRECARD_CCARD_JCB_CASE_SIGNATURE;
      $is3DS = (MODULE_PAYMENT_WIRECARD_CCARD_JCB_IS3DS=='true');
      break;
    case WIRE_CCARD_TYPE_AMEX:
      $user_id = MODULE_PAYMENT_WIRECARD_CCARD_AMEX_USER_ID;
      $user_pwd = MODULE_PAYMENT_WIRECARD_CCARD_AMEX_PASSWORD;
      $signature = MODULE_PAYMENT_WIRECARD_CCARD_AMEX_CASE_SIGNATURE;
      $is3DS = (MODULE_PAYMENT_WIRECARD_CCARD_AMEX_IS3DS=='true');
      break;
    case WIRE_CCARD_TYPE_MAESTRO:
      $user_id = MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_USER_ID;
      $user_pwd = MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_PASSWORD;
      $signature = MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_CASE_SIGNATURE;
      $is3DS = (MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_IS3DS=='true');
      break;
    default:
    case WIRE_CCARD_TYPE_MASTERCARD:
      $user_id = MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_USER_ID;
      $user_pwd = MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_PASSWORD;
      $signature = MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_CASE_SIGNATURE;
      $is3DS = (MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_IS3DS=='true');
      break;
    }            

    $transaction_id = md5(uniqid('', 1));
    $business_case_signature = $signature;
    if(function_exists(tep_get_countries)){
      $ar = tep_get_countries(STORE_COUNTRY, true);
    } else {
      $ar = tep_get_countrieslist(STORE_COUNTRY, true);
    }
    $country_code = $ar['countries_iso_code_2'];

    $data = $this->wc->getCustomerXMLData($_POST, $business_case_signature, $transaction_id, $amount, $currency, $country_code);
    $text_xml = $this->wc->getPaymentXML($data, $is3DS);
    if (MODULE_PAYMENT_WIRECARD_CCARD_DEBUG == 'true'){ 
      echo "<pre>"; echo htmlspecialchars($text_xml); echo "</pre>";
    }
    if ($is3DS){
      $_SESSION['wc_old_data']['data']      = $data;
      $_SESSION['wc_old_data']['user_id']   = $user_id;
      $_SESSION['wc_old_data']['user_pwd']  = $user_pwd;
      $_SESSION['wc_old_data']['signature'] = $signature;
    }

    $response = $this->wc->doWCXMLRequest($user_id, $user_pwd, $signature, $text_xml, $is3DS, $data);
    if (MODULE_PAYMENT_WIRECARD_CCARD_DEBUG == 'true') {
      echo "<pre>"; echo htmlspecialchars($response); echo "</pre>";
    }

    $retarr = $this->wc->decodeXML($response);
    if (MODULE_PAYMENT_WIRECARD_CCARD_DEBUG == 'true') {
      echo "<pre>"; print_r($retarr); echo "</pre>"; exit;
    }

    // Wenn 3DS Enrollment OK dann zur Bank
    if (isset($retarr['PAReq']) && isset($retarr['AcsUrl'])){
      $form  = '<html><head></head><body><form method="POST" action="'.$retarr['AcsUrl'].'"';
    	$form .= ' name="payauthForm" id="payauthForm">';
  		$form .= '<input type="hidden" name="MD" value="'.(int)$insert_id.'">';
	  	$form .= '<input type="hidden" name="TermUrl" value="'.tep_href_link('wirecard_3ds.php', $this->sid, 'SSL', '', false).'">';
		  $form .= '<input type="hidden" name="PaReq" value="'.$retarr['PAReq'].'">';
  		$form .= '</form><script>document.getElementById("payauthForm").submit();</script></body></html>';
      echo $form;
      $_SESSION['wc_old_data']['GuWID'] = $retarr['GuWID'];
      exit();
    }
    
    if (($retarr['FunctionResult'] == 'PENDING') || ($retarr['FunctionResult'] == 'ACK')){
      $this->GuWID = $retarr['GuWID'];
      // Warenkorb leeren
      $cart->reset(true);
      tep_db_query("UPDATE " . TABLE_ORDERS . " SET orders_wirecard_guwid = '" . tep_db_input($this->GuWID) . "' WHERE orders_id = '" . (int)$insert_id . "'");
      tep_db_query("UPDATE " . TABLE_ORDERS . " SET orders_status = '" . MODULE_PAYMENT_WIRECARD_CCARD_ORDER_STATUS_PAID_ID . "' WHERE orders_id = '" . (int)$insert_id . "'");
      tep_mail($order->customer['firstname'] . ' ' . $order->customer['lastname'], $order->customer['email_address'], EMAIL_TEXT_SUBJECT, $email_order, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
  
      // send emails to other people
      if (SEND_EXTRA_ORDER_EMAILS_TO != '') {
        tep_mail('', SEND_EXTRA_ORDER_EMAILS_TO, EMAIL_TEXT_SUBJECT, $email_order, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
      }
      
      tep_redirect(tep_href_link('checkout_success.php', $this->sid, 'SSL', '', false));
    } else {
      tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode(MODULE_PAYMENT_WIRECARD_CCARD_ERROR_HEADING . ' ' 
        . ($retarr['Message'] ? $retarr['Message'] : MODULE_PAYMENT_WIRECARD_CCARD_ERROR_CURL)), 'SSL', true, false));
    }
    
  }/*}}}*/

  function after_process()/*{{{*/
  {
  }/*}}}*/

  function get_error()/*{{{*/
  {
    $error = array('title' => MODULE_PAYMENT_WIRECARD_CCARD_ERROR_HEADING,
      'error' => ((isset($_GET['error'])) ? stripslashes(urldecode($_GET['error'])) : MODULE_PAYMENT_WIRECARD_CCARD_ERROR_MESSAGE));

    return $error;
  }/*}}}*/

  function check()/*{{{*/
  {
    if (!isset($this->_check))
    {
      $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_WIRECARD_CCARD_STATUS'");
      $this->_check = tep_db_num_rows($check_query);
    }
    return $this->_check;
  }/*}}}*/

  function install()/*{{{*/
  {
    require_once(DIR_FS_CATALOG.DIR_WS_LANGUAGES.$_SESSION['language'].'/modules/payment/'.$this->code.'.php');
    
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, set_function, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_STATUS', 'True', '".MODULE_PAYMENT_WIRECARD_CCARD_STATUS_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_STATUS_DESC."', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, set_function, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_DEMO', 'True', '".MODULE_PAYMENT_WIRECARD_CCARD_DEMO_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_DEMO_DESC."', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_URL', 'https://c3-test.wirecard.com/secure/ssl-gateway', '".MODULE_PAYMENT_WIRECARD_CCARD_URL_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_URL_DESC."', '6', '2', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_CURL_PATH', 'NONE', '".MODULE_PAYMENT_WIRECARD_CCARD_CURL_PATH_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_CURL_PATH_DESC."', '6', '0', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_SORT_ORDER', '0', '".MODULE_PAYMENT_WIRECARD_CCARD_SORT_ORDER_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_SORT_ORDER_DESC."', '6', '0', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_ZONE', '0', '".MODULE_PAYMENT_WIRECARD_CCARD_ZONE_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_ZONE_DESC."', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_ORDER_STATUS_ID', '0', '".MODULE_PAYMENT_WIRECARD_CCARD_ORDER_STATUS_ID_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_ORDER_STATUS_ID_DESC."', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_ORDER_STATUS_PAID_ID', '0', '".MODULE_PAYMENT_WIRECARD_CCARD_ORDER_STATUS_PAID_ID_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_ORDER_STATUS_PAID_ID_DESC."', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description,	configuration_group_id, sort_order, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_ALLOWED', '', '".MODULE_PAYMENT_WIRECARD_CCARD_ALLOWED_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_ALLOWED_DESC."', '6', '0', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, set_function, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_DEBUG', 'false', '".MODULE_PAYMENT_WIRECARD_CCARD_DEBUG_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_DEBUG_DESC."', '6', '1', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())"
    );


    # MasterCard
    tep_db_query("insert into ".TABLE_CONFIGURATION." (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, set_function, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_MASTERCARD','False', '".MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_MASTERCARD_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_MASTERCARD_DESC."', 6, 0, 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_USER_ID', '56500', '".MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_USER_ID_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_USER_ID_DESC."', '6', '3', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_PASSWORD', 'TestXAPTER', '".MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_PASSWORD_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_PASSWORD_DESC."', '6', '4', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_CASE_SIGNATURE', '56500', '".MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_CASE_SIGNATURE_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_CASE_SIGNATURE_DESC."', '6', '3', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, set_function, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_IS3DS', 'false', '".MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_IS3DS_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_IS3DS_DESC."', '6', '1', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())"
    );

    # Visa
    tep_db_query("insert into ".TABLE_CONFIGURATION." (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, set_function, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_VISA','False', '".MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_VISA_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_VISA_DESC."', 6, 0, 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_VISA_USER_ID', '56500', '".MODULE_PAYMENT_WIRECARD_CCARD_VISA_USER_ID_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_VISA_USER_ID_DESC."', '6', '3', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_VISA_PASSWORD', 'TestXAPTER', '".MODULE_PAYMENT_WIRECARD_CCARD_VISA_PASSWORD_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_VISA_PASSWORD_DESC."', '6', '4', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_VISA_CASE_SIGNATURE', '56500', '".MODULE_PAYMENT_WIRECARD_CCARD_VISA_CASE_SIGNATURE_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_VISA_CASE_SIGNATURE_DESC."', '6', '3', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, set_function, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_VISA_IS3DS', 'false', '".MODULE_PAYMENT_WIRECARD_CCARD_VISA_IS3DS_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_VISA_IS3DS_DESC."', '6', '1', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())"
    );

    # JCB
    tep_db_query("insert into ".TABLE_CONFIGURATION." (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, set_function, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_JCB','False', '".MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_JCB_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_JCB_DESC."', 6, 0, 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_JCB_USER_ID', '56500', '".MODULE_PAYMENT_WIRECARD_CCARD_JCB_USER_ID_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_JCB_USER_ID_DESC."', '6', '3', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_JCB_PASSWORD', 'TestXAPTER', '".MODULE_PAYMENT_WIRECARD_CCARD_JCB_PASSWORD_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_JCB_PASSWORD_DESC."', '6', '4', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_JCB_CASE_SIGNATURE', '56500', '".MODULE_PAYMENT_WIRECARD_CCARD_JCB_CASE_SIGNATURE_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_JCB_CASE_SIGNATURE_DESC."', '6', '3', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, set_function, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_JCB_IS3DS', 'false', '".MODULE_PAYMENT_WIRECARD_CCARD_JCB_IS3DS_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_JCB_IS3DS_DESC."', '6', '1', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())"
    );

    # AMEX
    tep_db_query("insert into ".TABLE_CONFIGURATION." (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, set_function, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_AMEX','False', '".MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_AMEX_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_AMEX_DESC."', 6, 0, 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_AMEX_USER_ID', '56500', '".MODULE_PAYMENT_WIRECARD_CCARD_AMEX_USER_ID_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_AMEX_USER_ID_DESC."', '6', '3', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_AMEX_PASSWORD', 'TestXAPTER', '".MODULE_PAYMENT_WIRECARD_CCARD_AMEX_PASSWORD_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_AMEX_PASSWORD_DESC."', '6', '4', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_AMEX_CASE_SIGNATURE', '56500', '".MODULE_PAYMENT_WIRECARD_CCARD_AMEX_CASE_SIGNATURE_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_AMEX_CASE_SIGNATURE_DESC."', '6', '3', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, set_function, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_AMEX_IS3DS', 'false', '".MODULE_PAYMENT_WIRECARD_CCARD_AMEX_IS3DS_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_AMEX_IS3DS_DESC."', '6', '1', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())"
    );
    
    # Maestro
    tep_db_query("insert into ".TABLE_CONFIGURATION." (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, set_function, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_MAESTRO','False', '".MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_MAESTRO_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_MAESTRO_DESC."', 6, 0, 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_USER_ID', '56500', '".MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_USER_ID_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_USER_ID_DESC."', '6', '3', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_PASSWORD', 'TestXAPTER', '".MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_PASSWORD_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_PASSWORD_DESC."', '6', '4', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_CASE_SIGNATURE', '56500', '".MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_CASE_SIGNATURE_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_CASE_SIGNATURE_DESC."', '6', '3', now())"
    );
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (
      configuration_key, configuration_value, configuration_title, configuration_description, configuration_group_id, sort_order, set_function, date_added
    ) values (
      'MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_IS3DS', 'false', '".MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_IS3DS_TITLE."', '".MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_IS3DS_DESC."', '6', '1', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())"
    );

  }/*}}}*/

  function remove()/*{{{*/
  {
    tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
  }/*}}}*/

  function keys()/*{{{*/
  {
    return array(
      'MODULE_PAYMENT_WIRECARD_CCARD_STATUS', 
      'MODULE_PAYMENT_WIRECARD_CCARD_URL', 
      'MODULE_PAYMENT_WIRECARD_CCARD_ZONE', 
      'MODULE_PAYMENT_WIRECARD_CCARD_ORDER_STATUS_ID', 
      'MODULE_PAYMENT_WIRECARD_CCARD_ORDER_STATUS_PAID_ID',
      'MODULE_PAYMENT_WIRECARD_CCARD_CURL_PATH', 
      'MODULE_PAYMENT_WIRECARD_CCARD_SORT_ORDER',

      'MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_MASTERCARD', 
      'MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_USER_ID', 
      'MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_PASSWORD', 
      'MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_CASE_SIGNATURE',
      'MODULE_PAYMENT_WIRECARD_CCARD_MASTERCARD_IS3DS', 

      'MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_VISA', 
      'MODULE_PAYMENT_WIRECARD_CCARD_VISA_USER_ID', 
      'MODULE_PAYMENT_WIRECARD_CCARD_VISA_PASSWORD', 
      'MODULE_PAYMENT_WIRECARD_CCARD_VISA_CASE_SIGNATURE', 
      'MODULE_PAYMENT_WIRECARD_CCARD_VISA_IS3DS', 

      'MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_JCB', 
      'MODULE_PAYMENT_WIRECARD_CCARD_JCB_USER_ID', 
      'MODULE_PAYMENT_WIRECARD_CCARD_JCB_PASSWORD', 
      'MODULE_PAYMENT_WIRECARD_CCARD_JCB_CASE_SIGNATURE', 
      'MODULE_PAYMENT_WIRECARD_CCARD_JCB_IS3DS', 

      'MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_AMEX', 
      'MODULE_PAYMENT_WIRECARD_CCARD_AMEX_USER_ID', 
      'MODULE_PAYMENT_WIRECARD_CCARD_AMEX_PASSWORD', 
      'MODULE_PAYMENT_WIRECARD_CCARD_AMEX_CASE_SIGNATURE', 
      'MODULE_PAYMENT_WIRECARD_CCARD_AMEX_IS3DS', 

      'MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_MAESTRO', 
      'MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_USER_ID', 
      'MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_PASSWORD', 
      'MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_CASE_SIGNATURE',
      'MODULE_PAYMENT_WIRECARD_CCARD_MAESTRO_IS3DS',  

      'MODULE_PAYMENT_WIRECARD_CCARD_DEBUG'
    );
  }/*}}}*/

}
?>
